#tag Module
Protected Module LDS_DesktopPopupMenu_Extensions
	#tag Method, Flags = &h0
		Sub AddRowWithTag(extends pum as desktopPopupMenu, item as DesktopMenuItem, tag as Variant)
		  pum.AddRow(item)
		  pum.RowTagAt(pum.LastAddedRowIndex)=tag
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddRowWithTag(extends pum as desktopPopupMenu, item as string, tag as Variant)
		  pum.AddRow(item)
		  pum.RowTagAt(pum.LastAddedRowIndex)=tag
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddRowWithTagAt(extends pum as desktopPopupMenu, index as integer, item as DesktopMenuItem, tag as Variant)
		  pum.AddRowAt(Index,item)
		  pum.RowTagAt(Index)=tag
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddRowWithTagAt(extends pum as desktopPopupMenu, index as integer, item as string, tag as Variant)
		  pum.AddRowAt(Index,item)
		  pum.RowTagAt(Index)=tag
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function IndexOfRow(extends pum as desktopPopupMenu, value as string, startIndex as integer = 0) As integer
		  for i as integer = startIndex to pum.LastRowIndex
		    if(pum.RowValueAt(i) = value) then return i
		  next
		  var e as new OutOfBoundsException
		  e.message = "Row value '"+value+"' not found in the menu's items"
		  raise e
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function IndexOfRowTag(extends pum as desktopPopupMenu, value as string, startIndex as integer = 0) As integer
		  for i as integer = startIndex to pum.LastRowIndex
		    if(pum.RowTagAt(i) = value) then return i
		  next
		  var e as new OutOfBoundsException
		  e.message = "Tag value '"+value+"' not found in the menu's items"
		  Raise e
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function RowAt(extends pum as DesktopPopupMenu, index as integer) As string
		  //RowValueAt will throw an exception if index is out of valid range
		  return pum.RowValueAt(index)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function SelectedRowTag(extends pum as desktopPopupMenu) As variant
		  //RowTagAt will throw an exception if index is out of range
		  return pum.RowTagAt(pum.SelectedRowIndex)
		End Function
	#tag EndMethod


	#tag Note, Name = Revision History
		October 16, 2022 - Initial implementation
		October 27, 2022 - set message for exceptions and added a few comments
		
	#tag EndNote


	#tag ViewBehavior
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
	#tag EndViewBehavior
End Module
#tag EndModule
